package com.nisum.offertransactionservice.service;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;

import org.springframework.http.MediaType;
import org.springframework.test.web.reactive.server.WebTestClient;
import reactor.core.publisher.Mono;

@RunWith(MockitoJUnitRunner.class)
public class EndOfTransactionTest {

    @Mock
    private EndOfTransactionService endOfTransactionService;

    @Mock
    private WebTestClient webTestClient;

    @Before
    public void setUp() throws Exception {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void getStringMonoTest() {
        String uuid = "86fd4146-0540-405b-b621-a95f4ccdfa0d";
        webTestClient.post().uri("http://localhost:8081/store/producer")
                .contentType(MediaType.APPLICATION_JSON)
                .body(Mono.just(uuid), String.class)
                .exchange()
                .expectBody().json("");
    }

    @Test
    public void endOfTransaction() {
        String uuid = "86fd4146-0540-405b-b621-a95f4ccdfa0d";
        Mockito.when(endOfTransactionService.getStringMono(uuid)).thenReturn(Mono.just(""));
        Assert.assertNotNull(endOfTransactionService.endOfTransaction(uuid));
    }
}
